#!/usr/bin/perl
use strict;

($#ARGV==1) or die "Usage: $0 annotfile D < (a)varsites\n"; 
my $annotFile = shift;
my $D = shift;

my %From;
my %To;

open(F, "<$annotFile") or die "Could not open annotation file $annotFile.\n";
while (<F>) {
  chomp;

  next if !/\texon\t/;

  # chr11   protein_coding  exon    128171  128242  .       +       .        gene_id "ENSG00000226743"; transcript_id "ENST00000435119"; exon_number "1"; gene_name "AC069287.1"; transcript_name "AC069287.1-201";
  /^(\S+)\t\S+\texon\t(\d+)\t(\d+)\t\S\t(\S)\t/ or die "Illegal line in gtf file. $_";
  my ($chrom,$from,$to,$ori) = ($1,$2,$3,$4);

  $From{"$chrom:$from"} = 1;
  $To{"$chrom:$to"} = 1;
}
close(F);

while (<>) {
  chomp;

  my ($chrom,$pos,$report);
  $report = 1;

  if (/^(\S+)\s(\d+)\s/) {
    ($chrom,$pos) = ($1,$2);
  } else {
    die "illegal edit line. $_";
  }

  my ($f,$t);
  for (my $d=1; $d<=$D; $d++) {
    my $f = $pos+$d; 
    if (defined($From{"$chrom:$f"})) { $report = 0; last; };
  }
  for (my $d=1; $d<=$D; $d++) {
    my $t = $pos-$d;
    if (defined($To{"$chrom:$t"})) { $report = 0; last; };
  }
  if ($report) {
    print $_ . "\n";
  }
}
