#!/usr/bin/perl
use strict;

# Input file format:
# chr1    14643   G       177     ,$,$,$,$,$,$,$....

while (<>) {

  /^(\S+)\t(\d+)\t(\S)\t(\d+)\t(\S+)\t/ or die "illegal line. $_";
  my ($chrom,$pos,$refbase,$numreads,$match_list) = ($1,$2,$3,$4,$5);

  my $rev_match_count = ($match_list =~ tr/,acgt/,acgt/);
  my $fwd_match_count = ($match_list =~ tr/\.ACGT/\.ACGT/);

  ($rev_match_count+$fwd_match_count==$numreads) or
     print STDERR "TROUBLE: ($fwd_match_count+$rev_match_count!=$numreads).\n";

  if (($fwd_match_count!=$numreads) && ($fwd_match_count!=0)) {
     print $_;
  }
}
