#!/usr/bin/perl
use strict;

# Input file format:
# chr1    14643   G       177     ,$,$,$,$,$,$,$....


while (<>) {

  /^(\S+)\t(\d+)\t(\S)\t(\d+)\t(\S+)\t/ or die "illegal line. $_";
  my ($chrom,$pos,$refbase,$numreads,$match_list) = ($1,$2,$3,$4,$5);

  my $match_count = ($match_list =~ tr/\.,/\.,/);
  my $A_count = ($match_list =~ tr/Aa/Aa/);
  my $C_count = ($match_list =~ tr/Cc/Cc/);
  my $G_count = ($match_list =~ tr/Gg/Gg/);
  my $T_count = ($match_list =~ tr/Tt/Tt/);

  my $match_count_r = ($match_list =~ tr/,/,/);
  my $A_count_r = ($match_list =~ tr/a/a/);
  my $C_count_r = ($match_list =~ tr/c/c/);
  my $G_count_r = ($match_list =~ tr/g/g/);
  my $T_count_r = ($match_list =~ tr/t/t/);

  if ($refbase eq 'A') { $A_count = $match_count;  $A_count_r = $match_count_r; } 
  if ($refbase eq 'C') { $C_count = $match_count;  $C_count_r = $match_count_r; }
  if ($refbase eq 'G') { $G_count = $match_count;  $G_count_r = $match_count_r; }
  if ($refbase eq 'T') { $T_count = $match_count;  $T_count_r = $match_count_r; }
  
  if ($A_count && (($A_count==$A_count_r) || ($A_count_r==0))) { print STDERR "Fail A ($chrom:$pos).\n"; next; } 
  if ($C_count && (($C_count==$C_count_r) || ($C_count_r==0))) { print STDERR "Fail C ($chrom:$pos).\n"; next; }
  if ($G_count && (($G_count==$G_count_r) || ($G_count_r==0))) { print STDERR "Fail G ($chrom:$pos).\n"; next; }
  if ($T_count && (($T_count==$T_count_r) || ($T_count_r==0))) { print STDERR "Fail T ($chrom:$pos).\n"; next; }

  print $_;
}
