#!/usr/bin/perl
use strict;

($#ARGV==0) or die "Usage: $0 heterozygous < (a)varsites\n";

my $hetFile = shift;

my %Pass;
open(F, "<$hetFile") or die "$hetFile.\n";
$_ = <F>;  # skip over header line
while (<F>) {
  chomp;

  /^(\S+):(\d+) \S+$/ or die "illegal line in syscall.heterozygous file. $_";
  my ($chrom,$pos) = ($1,$2);
  $Pass{"$chrom:$pos"} = 1;
}
close(F);

while (<>) {

  /^(\S+)\t(\d+)\t/ or die "illegal input variable site line. $_";
  next if !defined($Pass{"$1:$2"});
  print $_;
}

