#!/usr/bin/perl
use strict;

#      chrY    13310615        G

($#ARGV==0) or die "Usage: $0 genome < (var)sites\n";

my $GENOME = shift;

my %GAid;
open(F, "<$GENOME") or die "could not open genome fasta file. $GENOME\n";
my $count = 0;
while (<F>) {
  chomp;
  if (/>/) {
    if (/^>(\S+)\s/)  { $GAid{$1} = $count; }
    elsif (/^>(\S+)$/) { $GAid{$1} = $count; }
    $count++;
  }
}
close(F);
printf STDERR "Done reading the genome...\n";

my $crtGAid;
my $Scaff;
while (<>) {
   chomp;

   /^(\S+)\t(\d+)\t(\S)\t/ or die "illegal line. $_";  
   my ($chrom,$pos,$base) = ($1,$2,$3);

   defined($GAid{$chrom}) or die "undefined GAid for $chrom.\n"; 

   if (!defined($crtGAid) || ($crtGAid != $GAid{$chrom})) {
     $crtGAid = $GAid{$chrom};
     $Scaff = `leaff -F $GENOME -s $crtGAid | perl mytail.pl`;
   }
#  print $_ . "\n";
   my $word = substr($Scaff, $pos-3,5); 
   print "$chrom $pos " . join(' ', split(//,$word)) . "\n";
}
